gopher.sh: fix LESS and colours
[gofetch.git] / gopher.sh
index 0042756538be4be9758e701ce79fe04c462b2b0a..f430d155355cb21fc703c08437d8663235088439 100755 (executable)
--- a/gopher.sh
+++ b/gopher.sh
@@ -1,5 +1,15 @@
 #!/bin/sh
 
+# $0 [server] ([selector]) ([port]) ([mode])
+#      server: the gopher server to dig to
+#      selector: the gopher selector (default is empty)
+#      port: the port to use (default is 70)
+#      mode: the filetype mode (default depends upon selector)
+#              0: plain text
+#              1: menu (dir-like)
+#              ...
+#              download: fake mode to download the result without changes
+
 # ENV variables:
 #      LINK_COLOR: escape sequences colour (def: 2)
 #              - : means no escape sequence
@@ -33,31 +43,35 @@ SL=
 EL=
 if [ "$LINK_COLOR" != "-" ]; then
        SL="`tput setf $LINK_COLOR``tput setaf $LINK_COLOR`"
-       EL="`tput init`";
+       EL="`tput init`"
+       export LESS="${LESS}-R"
 fi
 
+PREFIX="[0-9hIg]"
+
 # $0 [FILE]
 # Display a gopher menu for the given resource
 cat_menu() {
        i=0
-       cat "$1" | grep '^[i0-9]' | while read ln; do
-               ln="`echo "$ln" | cut -f1`"
+       cat "$1" | grep "^i\|^$PREFIX" | while read ln; do
                if echo "$ln" | grep "^i" >/dev/null 2>&1; then
-                       echo "$ln" | sed "s:^.: :g"
-               elif echo "$ln" | grep "^[0-9]" >/dev/null 2>&1; then
+                       echo "$ln" | cut -f1 | sed "s:^.:       :g"
+               elif echo "$ln" | grep "^$PREFIX" >/dev/null 2>&1; then
                        i=`expr $i + 1`
-                       i=`printf %2.f $i`
+                       [ $i -le 9 ] && i=0$i 
                        field="`echo "$ln" | cut -c1`"
                        case "$field" in
                                0) typ='TXT';;
-                               1) typ='DIR';;
-                               7) typ='(?)';;
-                               8) typ='TEL';;
+                               1) typ='DIR';; # menu, actually
+                               7) typ='(?)';; # query
+                               8) typ='TEL';; # TELnet (not TELephone)
+                               h) typ='WEB';; # HTML
+                               I) typ='IMG';;
+                               g) typ='GIF';;
+                               +) typ='SVR';; # redundant server
                                *) typ='!!!';;
                        esac
-                       echo "$ln" | sed "s:^.\\(.*\\):$typ $i  $SL\\1$EL:g"
-               #else
-                       # Bad line
+                       echo "$ln" | sed "s:^.\\([^\t]*\\).*:$typ $i    $SL\\1$EL:g"
                fi
        done
 }
@@ -71,12 +85,13 @@ cat_menu() {
 #      3 = server
 #      4 = port
 getsel() {
-       cat "$1" | grep '^[0-9]' | tail -n+"$2" | head -n 1 | cut -f"$3"
+       cat "$1" | grep "^$PREFIX" | tail -n+"$2" | head -n 1 | cut -f"$3"
 }
 
+# Save page content to 'tmp' file
 tmp="`mktemp -t gofetch.current_page.XXXXXX`"
 finish() {
-  rm -rf "$tmp"
+  rm -rf "$tmp" "$tmp.jpg"
 }
 trap finish EXIT
 
@@ -86,15 +101,21 @@ else
        echo "$SELECTOR" | nc "$SERVER" "$PORT" > "$tmp"
 fi
 
+# Process page content
 case "$MODE" in
+download)
+       # Special, fake mode, only from top-level
+       cat "$tmp"
+;;
 0)
        cat "$tmp" | less
 ;;
-1)
+1|+)
        CHOICE=start
        while [ "$CHOICE" != "" ]; do
                cat_menu "$tmp" | less
                read -p "[$SELECTOR]: " CHOICE
+               [ "$CHOICE" = q ] && exit 255 # force-quit
                index="`expr 1 \* "$CHOICE" 2>/dev/null`"
                if [ "$index" != "" ]; then
                        goto_server="`getsel "$tmp" $index 3`"
@@ -102,6 +123,7 @@ case "$MODE" in
                        goto_port="`getsel "$tmp" $index 4`"
                        goto_mode="`getsel "$tmp" $index 1 | cut -c1`"
                        sh "$0" "$goto_server" "$goto_sel" "$goto_port" "$goto_mode"
+                       [ $? = 255 ] && exit 255 # force-quit
                fi
        done
 ;;
@@ -118,8 +140,27 @@ case "$MODE" in
 9)
        echo "<BINARY FILE>" | less
 ;;
+g|I)
+       if img2aa --help >/dev/null 2>&1; then
+               img2aa --mode=DITHERING \
+                       --width=74 "$tmp" | less
+       elif jp2a -h >/dev/null 2>&1; then
+               if convert -h >/dev/null 2>&1; then
+                       convert "$tmp" "$tmp.jpg"
+                       jp2a --border --chars=" .-+=o8#"\
+                               --width=74 "$tmp.jpg" | less
+               else
+                       echo "required program not found to view images: convert" \
+                               | less
+               fi
+       else
+               echo "required program not found to view images:" \
+                       jp2a or img2aa | less
+       fi
+;;
 *)
        echo "unknwon selector mode: <$MODE>" | less
        exit 3
 ;;
 esac
+